%define pkgname twm

Summary: X.Org X11 twm window manager
Name: xorg-x11-%{pkgname}
# NOTE: Remove Epoch line if package gets renamed to something like "twm"
Epoch: 1
Version: 1.0.1
Release: 1.2
License: MIT/X11
Group: User Interface/X
URL: http://www.x.org
Source0: http://xorg.freedesktop.org/releases/X11R7.0-RC4/everything/%{pkgname}-%{version}.tar.bz2
#Source0: %{pkgname}-%{version}.tar.bz2
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# checking TWM_LIBS... -lXmu -lXt -lSM -lICE -lXext -lX11 -ldl
BuildRequires: libX11-devel
BuildRequires: libXt-devel
BuildRequires: libXmu-devel
BuildRequires: libSM-devel
BuildRequires: libICE-devel
BuildRequires: libXext-devel
# FIXME: twm fails to link to libXau, however upstream ./configure checks, do
# not check for libXau in X11R7 RC2.  fdo#5065
BuildRequires: libXau-devel

# FIXME: monolithic twm packaging has a hard dep on xterm, which might still
# be required.  We'll have to examine the twm configuration files.
#Requires: xterm
Provides: twm

Obsoletes: XFree86-twm
# NOTE: The twm.1 manpage was moved from the XFree86 package to the twm
# package to fix bug #70025 on July 29 2002.  This must remain here as
# long as we support upgrading from OS releases that contained a version
# of XFree86 less than that indicated, both for the RHEL case, RHL case,
# and Fedora Core case. - Mike A. Harris<mharris@redhat.com>
Conflicts: XFree86 <= 4.2.0-57.1

%description
X.Org X11 twm window manager

%prep
%setup -q -c %{name}-%{version}

%build
cd %{pkgname}-%{version}
# FIXME: Work around pointer aliasing warnings from compiler for now
# events.c:279: warning: dereferencing type-punned pointer will break strict-aliasing rules
# events.c:282: warning: dereferencing type-punned pointer will break strict-aliasing rules
# events.c:306: warning: dereferencing type-punned pointer will break strict-aliasing rules
# events.c:309: warning: dereferencing type-punned pointer will break strict-aliasing rules
# events.c:369: warning: dereferencing type-punned pointer will break strict-aliasing rules
# events.c:521: warning: dereferencing type-punned pointer will break strict-aliasing rules
# events.c:1026: warning: dereferencing type-punned pointer will break strict-aliasing rules
# events.c:1270: warning: dereferencing type-punned pointer will break strict-aliasing rules
# events.c:1398: warning: dereferencing type-punned pointer will break strict-aliasing rules
# events.c:1462: warning: dereferencing type-punned pointer will break strict-aliasing rules
# events.c:1489: warning: dereferencing type-punned pointer will break strict-aliasing rules
# events.c:1846: warning: dereferencing type-punned pointer will break strict-aliasing rules
# events.c:2087: warning: dereferencing type-punned pointer will break strict-aliasing rules
# events.c:2244: warning: dereferencing type-punned pointer will break strict-aliasing rules
# events.c:2272: warning: dereferencing type-punned pointer will break strict-aliasing rules
# menus.c:521: warning: dereferencing type-punned pointer will break strict-aliasing rules
# menus.c:2673: warning: dereferencing type-punned pointer will break strict-aliasing rules
# menus.c:2857: warning: dereferencing type-punned pointer will break strict-aliasing rules
# parse.c:961: warning: dereferencing type-punned pointer will break strict-aliasing rules
# resize.c:541: warning: dereferencing type-punned pointer will break strict-aliasing rules
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
%configure
make

%install
rm -rf $RPM_BUILD_ROOT
cd %{pkgname}-%{version}
%makeinstall

# FIXME: Upstream sources do not create the system wide twm config dir, nor
# install the default config file currently.  We'll work around it here for now.
{
   echo "FIXME: Upstream doesn't install systemwide config by default"
   mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/X11/twm
   install -m 0644 src/system.twmrc $RPM_BUILD_ROOT%{_sysconfdir}/X11/twm/
}
%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc
%dir %{_bindir}
%{_bindir}/twm
%dir %{_mandir}
%dir %{_mandir}/man1
%{_mandir}/man1/twm.1x*
# FIXME: modular build is not installing the twm config currently, find out
# why and fix it.
%dir %{_sysconfdir}
%dir %{_sysconfdir}/X11/twm
%config %{_sysconfdir}/X11/twm/system.twmrc

%changelog
* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 1:1.0.1-1.2
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 1:1.0.1-1.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Wed Jan 18 2006 Mike A. Harris <mharris@redhat.com> 1:1.0.1-1
- Updated to twm 1.0.1 from X11R7.0

* Fri Dec 16 2005 Mike A. Harris <mharris@redhat.com> 1:1.0.0-1
- Updated to twm 1.0.0 from X11R7 RC4.
- Change manpage dir from man1x to man1 to match RC4 default.

* Tue Nov 15 2005 Mike A. Harris <mharris@redhat.com> 1:0.99.1-4
- Added "BuildRequires: libXau-devel", as twm fails without it, but does not
  check for it with ./configure.  Bug (fdo#5065)

* Wed Nov 2 2005 Mike A. Harris <mharris@redhat.com> 1:0.99.1-3
- Actually spell RPM_OPT_FLAGS correctly this time.

* Mon Oct 31 2005 Mike A. Harris <mharris@redhat.com> 1:0.99.1-2
- Build with -fno-strict-aliasing to work around possible pointer aliasing
  issues

* Mon Oct 31 2005 Mike A. Harris <mharris@redhat.com> 1:0.99.1-1
- Updated to twm 0.99.1 from X11R7 RC1.
- Added Epoch 1 to package, to be able to change the version number from the
  X11R7 release number to the actual twm version.
- Change manpage location to 'man1x' in file manifest

* Wed Oct 5 2005 Mike A. Harris <mharris@redhat.com> 6.99.99.0-2
- Update BuildRequires to match new library naming scheme
- Use Fedora Extras style BuildRoot declaration

* Wed Aug 24 2005 Mike A. Harris <mharris@redhat.com> 6.99.99.0-1
- Initial build.
